// DIODlg.cpp : implementation file
//

#include "stdafx.h"
#include "DIO.h"
#include "DIODlg.h"
#include "pacsdk.h"
#include "XWboardSDK.h"

extern void setGPIOOutput(unsigned int pin, unsigned int value);
extern void setGPIOOutput(unsigned int pin, unsigned int value);
extern void setGPIOInput(unsigned int pin);
extern void Set_GPIO_Pin_Status(unsigned int pin, unsigned int value);
extern int Get_GPIO_Pin_Status(unsigned int pin);
extern void setGPIO11_ClockOut(unsigned int enable);
extern void setGPIO_PWM(unsigned int pin,DWORD dwFrequency,unsigned int Duty,int enable);
extern  void setGPIOAltFunc(unsigned int pin, unsigned int af, unsigned int mode); 

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDIODlg dialog

CDIODlg::CDIODlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDIODlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDIODlg)
	m_Frequency = _T("");
	m_Duty = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDIODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDIODlg)
	DDX_Control(pDX, IDC_COMBO4, m_IOmode);
	DDX_Control(pDX, IDC_COMBO3, m_AF);
	DDX_Control(pDX, IDC_COMBO2, m_pin);
	DDX_Control(pDX, IDC_COMBO1, m_PWM);
	DDX_Control(pDX, IDC_RADIO1, m_ONOFF);
	DDX_Text(pDX, IDC_EDIT2, m_Frequency);
	DDX_Text(pDX, IDC_EDIT3, m_Duty);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDIODlg, CDialog)
	//{{AFX_MSG_MAP(CDIODlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio1)
	ON_BN_CLICKED(IDC_BUTTON10, OnButton10)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDIODlg message handlers

BOOL CDIODlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	m_IOmode.SetCurSel(0);
	m_AF.SetCurSel(0);
	m_pin.SetCurSel(0);

	m_PWM.SetCurSel(0);
	// TODO: Add extra initialization here
	SetDlgItemText(IDC_EDIT2,TEXT("1000"));
	SetDlgItemText(IDC_EDIT3,TEXT("60"));
	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CDIODlg::OnButton1() 
{
	TCHAR tcTemp[100]={0};
	int ipin;

	GetDlgItemText(IDC_COMBO2,tcTemp,100);
	ipin= _wtoi(tcTemp);
	setGPIOOutput(ipin,1);
}

void CDIODlg::OnButton7() 
{
	TCHAR tcTemp[100]={0};
	int ipin;

	GetDlgItemText(IDC_COMBO2,tcTemp,100);
	ipin= _wtoi(tcTemp);
	setGPIOInput(ipin);	
}

void CDIODlg::OnButton2() 
{
	TCHAR tcTemp[100]={0};
	int ipin;

	GetDlgItemText(IDC_COMBO2,tcTemp,100);
	ipin= _wtoi(tcTemp);
	Set_GPIO_Pin_Status(ipin,1);
//	printf("Pin %x\r\n",Get_GPIO_Pin_Status(ipin));
}

void CDIODlg::OnButton3() 
{
	TCHAR tcTemp[100]={0};
	int ipin;

	GetDlgItemText(IDC_COMBO2,tcTemp,100);
	ipin= _wtoi(tcTemp);
	Set_GPIO_Pin_Status(ipin,0);
//	printf("Pin %x\r\n",Get_GPIO_Pin_Status(ipin));
}

void CDIODlg::OnButton4() 
{
	setGPIO11_ClockOut(0);
}
void CDIODlg::OnButton5() 
{
	setGPIO11_ClockOut(1);
}


void CDIODlg::OnButton6() 
{

}



void CDIODlg::OnRadio1() 
{
	TCHAR Frequency[64];
	TCHAR Duty[64];
    DWORD   F,D;
	GetDlgItemText(IDC_EDIT2, Frequency, 64);
	GetDlgItemText(IDC_EDIT3, Duty, 64);
	F = _ttoi(Frequency);
	D = _ttoi(Duty);
	int ipin;
	ipin =m_PWM.GetCurSel();
	if (!m_ONOFF.GetCheck())
		setGPIO_PWM(ipin+16,F,D,1); //1 output on
	else
		setGPIO_PWM(ipin+16,F,D,0); //0 output off
}

void CDIODlg::OnButton10() 
{
	TCHAR tcTemp[100]={0};
	int ipin;

	GetDlgItemText(IDC_COMBO2,tcTemp,100);
	ipin= _wtoi(tcTemp);
	setGPIOAltFunc(ipin,m_AF.GetCurSel(),m_IOmode.GetCurSel());
}
