Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports XWBoardNet
Public Class Form1


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cmbGPOIPin.SelectedIndex = 0
        cmbFunction.SelectedIndex = 0
        cmbIOMode.SelectedIndex = 0
        cmbPWM.SelectedIndex = 0
    End Sub

    Private Sub btnOutput_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOutput.Click
        Dim i As Integer = Convert.ToInt16(cmbGPOIPin.Text)
        XWBoard.setGPIOOutput(i, 1)
    End Sub

    Private Sub btnInput_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnInput.Click
        Dim i As Integer = Convert.ToInt16(cmbGPOIPin.Text)
        XWBoard.setGPIOInput(i)
    End Sub

    Private Sub btnHigh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnHigh.Click
        Dim i As Integer = Convert.ToInt16(cmbGPOIPin.Text)
        XWBoard.Set_GPIO_Pin_Status(i, 1)
    End Sub

    Private Sub btnLow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLow.Click
        Dim i As Integer = Convert.ToInt16(cmbGPOIPin.Text)
        XWBoard.Set_GPIO_Pin_Status(i, 0)
    End Sub

    Private Sub btnSetAlternateFun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetAlternateFun.Click
        Dim i As Integer = Convert.ToInt16(cmbGPOIPin.Text)
        XWBoard.setGPIOAltFunc(i, cmbFunction.SelectedIndex, cmbIOMode.SelectedIndex)
    End Sub

    Private Sub button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button6.Click
        XWBoard.setGPIO11_ClockOut(1)
    End Sub

    Private Sub button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button7.Click
        XWBoard.setGPIO11_ClockOut(0)
    End Sub

    Private Sub checkBox1_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkBox1.CheckStateChanged
        If checkBox1.Checked Then
            XWBoard.setGPIO_PWM(Convert.ToInt16(cmbPWM.Text), CUInt(Convert.ToInt16(txbFrequency.Text)), Convert.ToInt16(txbDuty.Text), 1)
            checkBox2.Checked = False
        End If
    End Sub

    Private Sub checkBox2_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkBox2.CheckStateChanged
        If checkBox2.Checked Then
            XWBoard.setGPIO_PWM(Convert.ToInt16(cmbPWM.Text), CUInt(Convert.ToInt16(txbFrequency.Text)), Convert.ToInt16(txbDuty.Text), 0)
            checkBox1.Checked = False
        End If
    End Sub
End Class
