Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports System.Runtime.InteropServices
Imports XWBoardNet
Public Class Form1


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        comboBoxAiCh.SelectedIndex = 0
        comboBoxAoCh.SelectedIndex = 0

        XW310_Init()
        XW310_AnalogOut(0, 0.0F)
        XW310_AnalogOut(1, 0.0F)
    End Sub
    <DllImport("XW310.dll", EntryPoint:="XW310_Init")> _
    Public Shared Sub XW310_Init()
    End Sub
    <DllImport("XW310.dll", EntryPoint:="XW310_AnalogOut")> _
    Public Shared Sub XW310_AnalogOut(ByVal iChannel As Integer, ByVal fValue As Single)
    End Sub

    <DllImport("XW310.dll", EntryPoint:="XW310_ReadAi")> _
    Public Shared Function XW310_ReadAi(ByVal iChannel As Integer, ByRef fvalue As Single) As Boolean
    End Function


    <DllImport("XW310.dll", EntryPoint:="XW310_SetDelay")> _
    Public Shared Sub XW310_SetDelay(ByVal Delayms As Integer)
    End Sub
    Private Sub checkBox0_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkBox0.CheckStateChanged
        Dim dwDO As UInteger
        Dim dwDI As UInteger
        dwDO = 0
        dwDI = dwDO
        If checkBox0.Checked Then
            XWBoard.XWB_WriteDOBit(3, 0, 1)
        Else
            XWBoard.XWB_WriteDOBit(3, 0, 0)
        End If
        XWBoard.XWB_ReadDO(4, dwDO)
        textBox1.Text = "DO Readback=" & dwDO.ToString("X")
    End Sub

    Private Sub checkBox1_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkBox1.CheckStateChanged
        Dim dwDO As UInteger
        Dim dwDI As UInteger
        dwDO = 0
        dwDI = dwDO
        If checkBox1.Checked Then
            XWBoard.XWB_WriteDOBit(3, 1, 1)
        Else
            XWBoard.XWB_WriteDOBit(3, 1, 0)
        End If
        XWBoard.XWB_ReadDO(4, dwDO)
        textBox1.Text = "DO Readback=" & dwDO.ToString("X")
    End Sub

    Private Sub checkBox2_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkBox2.CheckStateChanged
        Dim dwDO As UInteger
        Dim dwDI As UInteger
        dwDO = 0
        dwDI = dwDO
        If checkBox2.Checked Then
            XWBoard.XWB_WriteDOBit(3, 2, 1)
        Else
            XWBoard.XWB_WriteDOBit(3, 2, 0)
        End If
        XWBoard.XWB_ReadDO(3, dwDO)
        textBox1.Text = "DO Readback=" & dwDO.ToString("X")
    End Sub
    Public Sub reverse(ByRef dwDI As UInteger)
        If checkBox4.Checked Then
            dwDI = dwDI Xor &H7

        End If
    End Sub
    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
        Dim dwDI As UInteger = 0
        XWBoard.XWB_ReadDI(3, dwDI)
        reverse(dwDI)
        textBox2.Text = "DI Readback=" & (dwDI And &H7).ToString("X")
    End Sub

    Private Sub button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button2.Click
        Dim iChannel_Readed As Integer
        Dim fAIValue As Single = 0
        XW310_SetDelay(125) 'If the value sets more big, the Ai read speed more slow, but the Ai read value more accurate

        iChannel_Readed = comboBoxAiCh.SelectedIndex
        If iChannel_Readed > 3 Then
            comboBoxAiCh.SelectedIndex = 3
            iChannel_Readed = 3
        End If
        XW310_ReadAi(iChannel_Readed, fAIValue)
        txbAiValue.Text = fAIValue.ToString()
    End Sub

    Private Sub button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button3.Click
        Dim fAoValue As Single = 0
        Dim iChannel_Readed As Integer

        fAoValue = CSng(Double.Parse(tBxAoValue.Text))
        iChannel_Readed = comboBoxAoCh.SelectedIndex
        XW310_AnalogOut(iChannel_Readed, fAoValue)
    End Sub

    Private Sub btnWriteDO0x55_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWriteDO0x55.Click
        Dim dwDO, dwDI As UInteger
        dwDO = 0
        dwDI = dwDO
        Try
            If Convert.ToUInt32(txtBDoValue.Text, 16) < (&H7 + 1) Then
                XWBoard.XWB_WriteDO(3, Convert.ToUInt32(txtBDoValue.Text, 16)) ' XW107 8DI 8DO
            Else
                MessageBox.Show("The XW310C only have 3 DO.")
                txtBDoValue.Text = "0x7"
            End If
        Catch ee As Exception
            MessageBox.Show("Error Value")
        End Try
        XWBoard.XWB_ReadDO(3, dwDO)

        textBox1.Text = "DO Readback=" & dwDO.ToString("X")
    End Sub
End Class
