Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports System.IO.Ports
Imports System.Net.Sockets
Imports Microsoft.Win32
Imports XWBoardNet
Imports System.Threading

Public Class Form1

    Private comPort As New SerialPort()
    Private lCmdPacketQuantity As Long = 0
    Private lCmdTotal As Long = 0
    Private lRevPacketSize As Long = 0
    Private lRevPacketQuantity As Long = 0
    Private lRevTotal As Long = 0
    Private endChr As String = ""
    Private sCmd As String = ""
    Private bCmd() As Byte
    Private sCRC As String = ""
    Private bCRC(1) As Byte
    Private bPolling As Boolean = False
    Private Shared ReadOnly crcTable() As UShort = {&H0, &HC0C1, &HC181, &H140, &HC301, &H3C0, &H280, &HC241, &HC601, &H6C0, &H780, &HC741, &H500, &HC5C1, &HC481, &H440, &HCC01, &HCC0, &HD80, &HCD41, &HF00, &HCFC1, &HCE81, &HE40, &HA00, &HCAC1, &HCB81, &HB40, &HC901, &H9C0, &H880, &HC841, &HD801, &H18C0, &H1980, &HD941, &H1B00, &HDBC1, &HDA81, &H1A40, &H1E00, &HDEC1, &HDF81, &H1F40, &HDD01, &H1DC0, &H1C80, &HDC41, &H1400, &HD4C1, &HD581, &H1540, &HD701, &H17C0, &H1680, &HD641, &HD201, &H12C0, &H1380, &HD341, &H1100, &HD1C1, &HD081, &H1040, &HF001, &H30C0, &H3180, &HF141, &H3300, &HF3C1, &HF281, &H3240, &H3600, &HF6C1, &HF781, &H3740, &HF501, &H35C0, &H3480, &HF441, &H3C00, &HFCC1, &HFD81, &H3D40, &HFF01, &H3FC0, &H3E80, &HFE41, &HFA01, &H3AC0, &H3B80, &HFB41, &H3900, &HF9C1, &HF881, &H3840, &H2800, &HE8C1, &HE981, &H2940, &HEB01, &H2BC0, &H2A80, &HEA41, &HEE01, &H2EC0, &H2F80, &HEF41, &H2D00, &HEDC1, &HEC81, &H2C40, &HE401, &H24C0, &H2580, &HE541, &H2700, &HE7C1, &HE681, &H2640, &H2200, &HE2C1, &HE381, &H2340, &HE101, &H21C0, &H2080, &HE041, &HA001, &H60C0, &H6180, &HA141, &H6300, &HA3C1, &HA281, &H6240, &H6600, &HA6C1, &HA781, &H6740, &HA501, &H65C0, &H6480, &HA441, &H6C00, &HACC1, &HAD81, &H6D40, &HAF01, &H6FC0, &H6E80, &HAE41, &HAA01, &H6AC0, &H6B80, &HAB41, &H6900, &HA9C1, &HA881, &H6840, &H7800, &HB8C1, &HB981, &H7940, &HBB01, &H7BC0, &H7A80, &HBA41, &HBE01, &H7EC0, &H7F80, &HBF41, &H7D00, &HBDC1, &HBC81, &H7C40, &HB401, &H74C0, &H7580, &HB541, &H7700, &HB7C1, &HB681, &H7640, &H7200, &HB2C1, &HB381, &H7340, &HB101, &H71C0, &H7080, &HB041, &H5000, &H90C1, &H9181, &H5140, &H9301, &H53C0, &H5280, &H9241, &H9601, &H56C0, &H5780, &H9741, &H5500, &H95C1, &H9481, &H5440, &H9C01, &H5CC0, &H5D80, &H9D41, &H5F00, &H9FC1, &H9E81, &H5E40, &H5A00, &H9AC1, &H9B81, &H5B40, &H9901, &H59C0, &H5880, &H9841, &H8801, &H48C0, &H4980, &H8941, &H4B00, &H8BC1, &H8A81, &H4A40, &H4E00, &H8EC1, &H8F81, &H4F40, &H8D01, &H4DC0, &H4C80, &H8C41, &H4400, &H84C1, &H8581, &H4540, &H8701, &H47C0, &H4680, &H8641, &H8201, &H42C0, &H4380, &H8341, &H4100, &H81C1, &H8081, &H4040}

    Private Sub AddReceive(ByVal s As Object, ByVal e As EventArgs)
        lRevPacketQuantity += 1
        Dim sTemp As String
        lRevPacketSize = comPort.BytesToRead
        sTemp = comPort.ReadExisting()
        'sTemp = sTemp.Replace("\n", ".");
        'sTemp = sTemp.Replace("\r", ".");
        txtReceive.Text = txtReceive.Text & sTemp
        lRevTotal = lRevTotal + lRevPacketSize
    End Sub
    Private Sub port_DataReceived(ByVal sender As Object, ByVal e As SerialDataReceivedEventArgs)
        Me.Invoke(New EventHandler(AddressOf AddReceive))

    End Sub
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        XWBoard.XWB_Init(0) 'auto scanner module
        textBox1.Text = "DO Readback=0x0" & ",DI=0x0"
        Dim i As Integer
        cmbBaud.SelectedIndex = 7
        cmbDataBit.SelectedIndex = 1
        cmbParity.SelectedIndex = 0
        cmbStopBit.SelectedIndex = 0
        rbCR.Checked = True
        AddHandler comPort.DataReceived, AddressOf port_DataReceived
        Dim counter As Integer = 10 'if com port number >10 change com port name
        For Each s As String In SerialPort.GetPortNames()
            If s.Length = 4 Then
                cmbPort.Items.Add(s)
            Else
                Dim ss As String
                ss = "COM" & counter.ToString() 'if open com X>10 the com porn name need +$device\ before com port name - "$device\" + 
                counter += 1
                cmbPort.Items.Add(ss)
            End If
        Next s
        cmbPort.SelectedIndex = 0

        For i = 1 To 8
            cmbPort.Items.Add(Convert.ToString("MSA" & i))
        Next i

        For i = 1 To 8
            cmbPort.Items.Add(Convert.ToString("MSB" & i))
        Next i
    End Sub
    Dim hPort As IntPtr
    Private Sub btOpenCOM_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btOpenCOM.Click
        comPort.BaudRate = Integer.Parse(cmbBaud.Text)
        comPort.DataBits = Integer.Parse(cmbDataBit.Text)
        If cmbParity.Text.Substring(0, 1) = "0" Then
            comPort.Parity = Parity.None
        ElseIf cmbParity.Text.Substring(0, 1) = "1" Then
            comPort.Parity = Parity.Odd
        ElseIf cmbParity.Text.Substring(0, 1) = "2" Then
            comPort.Parity = Parity.Even
        End If
        If cmbStopBit.Text = "0" Then
            comPort.StopBits = StopBits.None
        ElseIf cmbStopBit.Text = "1" Then
            comPort.StopBits = StopBits.One
        End If

        'comPort.StopBits = 

        Dim ComPortNumber As Integer = Int32.Parse(cmbPort.Text.Substring(3))
        If ComPortNumber > 9 Then
            comPort.PortName = "$device\" & "COM" & cmbPort.Text.Substring(3)
        Else
            comPort.PortName = cmbPort.Text
        End If


        If comPort.IsOpen = False Then
            Try
                If Int32.Parse(cmbPort.Text.Substring(3)) <> 0 Then
                    comPort.Open()
                    btCloseCOM.Enabled = True
                    btOpenCOM.Enabled = False
                    btSend.Enabled = True
                    'Else 'if open com0 use open com function in WinPacNet.dll
                    '    hPort = WinPAC.uart_Open("COM0")
                    '    btCloseCOM.Enabled = True
                    '    btOpenCOM.Enabled = False
                    '    btSend.Enabled = True
                End If
            Catch err As Exception
                MessageBox.Show(err.ToString())
            End Try
        End If
    End Sub

    Private Sub btCloseCOM_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btCloseCOM.Click
        btOpenCOM.Enabled = True
        btCloseCOM.Enabled = False
        btSend.Enabled = False
        comPort.Close()
        btSend.Enabled = False
    End Sub
    Private Sub SendStringToCOM(ByVal sData As String)
        comPort.Write(sData)
        lCmdTotal = lCmdTotal + sData.Length
    End Sub
    Private Sub btSend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btSend.Click
        lCmdPacketQuantity += 1
        sCmd = txtMsg.Text + endChr
        SendStringToCOM(sCmd)
    End Sub

    Private Sub rbNone_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbNone.CheckedChanged
        endChr = Chr(0)
    End Sub

    Private Sub rbLFCR_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbLFCR.CheckedChanged
        endChr = Chr(10) + Chr(13)
    End Sub

    Private Sub rbCR_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbCR.CheckedChanged
        endChr = Chr(13)
    End Sub

    Private Sub rbCRLF_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbCRLF.CheckedChanged
        endChr = Chr(13) + Chr(10)
    End Sub

    Private Sub rbLF_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbLF.CheckedChanged
        endChr = Chr(10)
    End Sub
    Public Sub reverse(ByRef dwDI As UInteger)
        If ckbReverse.Checked Then
            dwDI = dwDI Xor &H3F

        End If
    End Sub
    Private Sub btnWriteDO0x77_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWriteDO0x77.Click
        Dim dwDO, dwDI As UInteger
        dwDO = 0
        dwDI = dwDO
        Try
            If Convert.ToUInt32(txtBDoValue.Text, 16) < &H40 Then
                XWBoard.XWB_WriteDO(6, Convert.ToUInt32(txtBDoValue.Text, 16)) ' XW507 6DI 6DO 1 serial port
            Else
                MessageBox.Show("The XW507 only have 6 DO.")
                txtBDoValue.Text = "0x3F"
            End If
        Catch ee As Exception
            MessageBox.Show("Error Value")
        End Try
        XWBoard.XWB_ReadDO(6, dwDO)
        Thread.Sleep(1)
        XWBoard.XWB_ReadDI(6, dwDI)
        reverse(dwDI)
        textBox1.Text = "DO Readback=" & dwDO.ToString("X") & ",DI=" & dwDI.ToString("X")
    End Sub

    Private Sub checkBox0_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkBox0.CheckStateChanged
        Dim dwDO As UInteger
        Dim dwDI As UInteger
        dwDO = 0
        dwDI = dwDO
        If checkBox0.Checked Then
            XWBoard.XWB_WriteDOBit(6, 0, 1)
        Else
            XWBoard.XWB_WriteDOBit(6, 0, 0)
        End If
        XWBoard.XWB_ReadDO(6, dwDO)
        Thread.Sleep(1)
        XWBoard.XWB_ReadDI(6, dwDI)
        reverse(dwDI)
        textBox1.Text = "DO Readback=" & dwDO.ToString("X") & ",DI=" & dwDI.ToString("X")
    End Sub

    Private Sub checkBox1_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkBox1.CheckStateChanged
        Dim dwDO As UInteger
        Dim dwDI As UInteger
        dwDO = 0
        dwDI = dwDO
        If checkBox1.Checked Then
            XWBoard.XWB_WriteDOBit(6, 1, 1)
        Else
            XWBoard.XWB_WriteDOBit(6, 1, 0)
        End If
        XWBoard.XWB_ReadDO(6, dwDO)
        Thread.Sleep(1)
        XWBoard.XWB_ReadDI(6, dwDI)
        reverse(dwDI)
        textBox1.Text = "DO Readback=" & dwDO.ToString("X") & ",DI=" & dwDI.ToString("X")
    End Sub

    Private Sub checkBox2_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkBox2.CheckStateChanged
        Dim dwDO As UInteger
        Dim dwDI As UInteger
        dwDO = 0
        dwDI = dwDO
        If checkBox2.Checked Then
            XWBoard.XWB_WriteDOBit(6, 2, 1)
        Else
            XWBoard.XWB_WriteDOBit(6, 2, 0)
        End If
        XWBoard.XWB_ReadDO(6, dwDO)
        Thread.Sleep(1)
        XWBoard.XWB_ReadDI(6, dwDI)
        reverse(dwDI)
        textBox1.Text = "DO Readback=" & dwDO.ToString("X") & ",DI=" & dwDI.ToString("X")
    End Sub

    Private Sub checkBox3_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkBox3.CheckStateChanged
        Dim dwDO As UInteger
        Dim dwDI As UInteger
        dwDO = 0
        dwDI = dwDO
        If checkBox3.Checked Then
            XWBoard.XWB_WriteDOBit(6, 3, 1)
        Else
            XWBoard.XWB_WriteDOBit(6, 3, 0)
        End If
        XWBoard.XWB_ReadDO(6, dwDO)
        Thread.Sleep(1)
        XWBoard.XWB_ReadDI(6, dwDI)
        reverse(dwDI)
        textBox1.Text = "DO Readback=" & dwDO.ToString("X") & ",DI=" & dwDI.ToString("X")
    End Sub

    Private Sub checkBox4_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkBox4.CheckStateChanged
        Dim dwDO As UInteger
        Dim dwDI As UInteger
        dwDO = 0
        dwDI = dwDO
        If checkBox4.Checked Then
            XWBoard.XWB_WriteDOBit(6, 4, 1)
        Else
            XWBoard.XWB_WriteDOBit(6, 4, 0)
        End If
        XWBoard.XWB_ReadDO(6, dwDO)
        Thread.Sleep(1)
        XWBoard.XWB_ReadDI(6, dwDI)
        reverse(dwDI)
        textBox1.Text = "DO Readback=" & dwDO.ToString("X") & ",DI=" & dwDI.ToString("X")
    End Sub

    Private Sub checkBox5_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkBox5.CheckStateChanged
        Dim dwDO As UInteger
        Dim dwDI As UInteger
        dwDO = 0
        dwDI = dwDO
        If checkBox5.Checked Then
            XWBoard.XWB_WriteDOBit(6, 5, 1)
        Else
            XWBoard.XWB_WriteDOBit(6, 5, 0)
        End If
        XWBoard.XWB_ReadDO(6, dwDO)
        Thread.Sleep(1)
        XWBoard.XWB_ReadDI(6, dwDI)
        reverse(dwDI)
        textBox1.Text = "DO Readback=" & dwDO.ToString("X") & ",DI=" & dwDI.ToString("X")
    End Sub

    Private Sub Form1_Closed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        comPort.Close()
    End Sub
End Class
