﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using XWBoardNet;

namespace GPIO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnOutput_Click(object sender, EventArgs e)
        {
            int i=Convert.ToInt16(cmbGPOIPin.Text);
            XWBoard.setGPIOOutput(i, 1);
        }

        private void btnInput_Click(object sender, EventArgs e)
        {
            int i = Convert.ToInt16(cmbGPOIPin.Text);
            XWBoard.setGPIOInput(i);
        }

        private void btnHigh_Click(object sender, EventArgs e)
        {
            int i = Convert.ToInt16(cmbGPOIPin.Text);
            XWBoard.Set_GPIO_Pin_Status(i, 1);
        }

        private void btnLow_Click(object sender, EventArgs e)
        {
            int i = Convert.ToInt16(cmbGPOIPin.Text);
            XWBoard.Set_GPIO_Pin_Status(i, 0);
        }

        private void btnSetAlternateFun_Click(object sender, EventArgs e)
        {
            int i = Convert.ToInt16(cmbGPOIPin.Text);
            XWBoard.setGPIOAltFunc(i, cmbFunction.SelectedIndex, cmbIOMode.SelectedIndex);
        }

        private void button6_Click(object sender, EventArgs e)
        {
            XWBoard.setGPIO11_ClockOut(1);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            XWBoard.setGPIO11_ClockOut(0);
        }

        private void checkBox1_CheckStateChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked)
            {
                XWBoard.setGPIO_PWM(Convert.ToInt16(cmbPWM.Text), (uint)Convert.ToInt16(txbFrequency.Text), Convert.ToInt16(txbDuty.Text), 1);
                checkBox2.Checked = false;
            }
        }

        private void checkBox2_CheckStateChanged(object sender, EventArgs e)
        {
            if (checkBox2.Checked)
            {
                XWBoard.setGPIO_PWM(Convert.ToInt16(cmbPWM.Text), (uint)Convert.ToInt16(txbFrequency.Text), Convert.ToInt16(txbDuty.Text), 0);
                checkBox1.Checked = false;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            cmbGPOIPin.SelectedIndex=0;
            cmbFunction.SelectedIndex=0;
            cmbIOMode.SelectedIndex=0;
            cmbPWM.SelectedIndex = 0;
        }

        private void cmbFunction_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

    }
}