// DIODlg.cpp : implementation file
//

#include "stdafx.h"
#include "DIO.h"
#include "DIODlg.h"
#include "pacsdk.h"
#include "XWboardSDK.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDIODlg dialog

CDIODlg::CDIODlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDIODlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDIODlg)
	m_Channel = _T("0");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDIODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDIODlg)
	DDX_Control(pDX, IDC_CHECK1, m_ch0);
	DDX_Control(pDX, IDC_CHECK2, m_ch1);
	DDX_Control(pDX, IDC_CHECK3, m_ch2);
	DDX_Control(pDX, IDC_CHECK4, m_ch3);
	DDX_Control(pDX, IDC_CHECK5, m_ch4);
	DDX_Control(pDX, IDC_CHECK6, m_ch5);
	DDX_Control(pDX, IDC_CHECK7, m_ch6);
	DDX_Control(pDX, IDC_CHECK8, m_ch7);
	DDX_Control(pDX, IDC_CHECK9, m_DiReverse);
	DDX_Text(pDX, IDC_EDIT1, m_Channel);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDIODlg, CDialog)
	//{{AFX_MSG_MAP(CDIODlg)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_BN_CLICKED(IDC_CHECK3, OnCheck3)
	ON_BN_CLICKED(IDC_CHECK4, OnCheck4)
	ON_BN_CLICKED(IDC_CHECK5, OnCheck5)
	ON_BN_CLICKED(IDC_CHECK6, OnCheck6)
	ON_BN_CLICKED(IDC_CHECK7, OnCheck7)
	ON_BN_CLICKED(IDC_CHECK8, OnCheck8)
	ON_BN_CLICKED(IDC_CHECK9, OnCheck9)
	ON_BN_CLICKED(IDC_CHECK10, OnCheck10)
	ON_BN_CLICKED(IDC_CHECK11, OnCheck11)
	ON_BN_CLICKED(IDC_CHECK12, OnCheck12)
	ON_BN_CLICKED(IDC_CHECK13, OnCheck13)
	ON_BN_CLICKED(IDC_CHECK14, OnCheck14)
	ON_BN_CLICKED(IDC_CHECK15, OnCheck15)
	ON_BN_CLICKED(IDC_CHECK16, OnCheck16)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDIODlg message handlers

TCHAR tstemp[128];
 


BOOL CDIODlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen	
	XWB_Init(0);//auto scanner module
	SetDlgItemText(IDC_EDIT1,TEXT("0xFFF"));
    SetDlgItemText(IDC_EDIT2,TEXT("DO Readback=0x0"));
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDIODlg::OnButton5() 
{
	DWORD dwDO;
	TCHAR DoValue[10];
	GetDlgItemText(IDC_EDIT1,DoValue,128);
	if(_wtoi(DoValue)<0x100)
	{
	XWB_WriteDO(16,_wtoi(DoValue));// XW107 8DI 8D
	XWB_ReadDO(16,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
	}
	else
		SetDlgItemText(IDC_EDIT1,TEXT("0xFFFF"));	
}


void CDIODlg::OnCheck1() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch0.GetCheck())
		XWB_WriteDOBit(16,0,1);
	else
		XWB_WriteDOBit(16,0,0);
	XWB_ReadDO(16,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
}

void CDIODlg::OnCheck2() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch1.GetCheck())
		XWB_WriteDOBit(16,1,1);
	else
		XWB_WriteDOBit(16,1,0);
	XWB_ReadDO(16,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
}

void CDIODlg::OnCheck3() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch2.GetCheck())
		XWB_WriteDOBit(16,2,1);
	else
		XWB_WriteDOBit(16,2,0);
	XWB_ReadDO(16,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
}

void CDIODlg::OnCheck4() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch3.GetCheck())
		XWB_WriteDOBit(16,3,1);
	else
		XWB_WriteDOBit(16,3,0);
	XWB_ReadDO(16,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
}

void CDIODlg::OnCheck5() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch4.GetCheck())
		XWB_WriteDOBit(16,4,1);
	else
		XWB_WriteDOBit(16,4,0);
	XWB_ReadDO(16,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
}

void CDIODlg::OnCheck6() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch5.GetCheck())
		XWB_WriteDOBit(16,5,1);
	else
		XWB_WriteDOBit(16,5,0);
	XWB_ReadDO(16,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
}

void CDIODlg::OnCheck7() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch6.GetCheck())
		XWB_WriteDOBit(16,6,1);
	else
		XWB_WriteDOBit(16,6,0);
	XWB_ReadDO(16,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
}

void CDIODlg::OnCheck8() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch7.GetCheck())
		XWB_WriteDOBit(16,7,1);
	else
		XWB_WriteDOBit(16,7,0);
	XWB_ReadDO(16,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
}

void CDIODlg::OnCheck9() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch8.GetCheck())
		XWB_WriteDOBit(16,8,1);
	else
		XWB_WriteDOBit(16,8,0);
	XWB_ReadDO(16,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
	
}

void CDIODlg::OnCheck10() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch9.GetCheck())
		XWB_WriteDOBit(16,9,1);
	else
		XWB_WriteDOBit(16,9,0);
	XWB_ReadDO(16,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
	
}

void CDIODlg::OnCheck11() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch10.GetCheck())
		XWB_WriteDOBit(16,10,1);
	else
		XWB_WriteDOBit(16,10,0);
	XWB_ReadDO(16,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
	
}

void CDIODlg::OnCheck12() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch11.GetCheck())
		XWB_WriteDOBit(16,11,1);
	else
		XWB_WriteDOBit(16,11,0);
	XWB_ReadDO(16,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
	
}

void CDIODlg::OnCheck13() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch12.GetCheck())
		XWB_WriteDOBit(16,12,1);
	else
		XWB_WriteDOBit(16,12,0);
	XWB_ReadDO(16,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
	
}

void CDIODlg::OnCheck14() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch13.GetCheck())
		XWB_WriteDOBit(16,13,1);
	else
		XWB_WriteDOBit(16,13,0);
	XWB_ReadDO(16,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
	
}

void CDIODlg::OnCheck15() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch14.GetCheck())
		XWB_WriteDOBit(16,14,1);
	else
		XWB_WriteDOBit(16,14,0);
	XWB_ReadDO(16,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
	
}

void CDIODlg::OnCheck16() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch15.GetCheck())
		XWB_WriteDOBit(16,15,1);
	else
		XWB_WriteDOBit(16,15,0);
	XWB_ReadDO(16,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
	
}
