Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports XWBoardNet
Imports System.Runtime.InteropServices
Imports System.Threading

Public Class Form1

    Public Sub reverse(ByRef dwDI As UInteger)
        If checkBox4.Checked Then
            dwDI = dwDI Xor &HF

        End If
    End Sub
    <DllImport("XW304.dll", EntryPoint:="XW304_ReadAi")> _
    Public Shared Function XW304_ReadAi(ByVal iChannel As Integer, ByVal AI_TYPE As Integer, ByRef fvalue As Single) As Boolean
    End Function
    <DllImport("XW304.dll", EntryPoint:="XW304_Init")> _
    Public Shared Sub XW304_Init()
    End Sub
    <DllImport("XW304.dll", EntryPoint:="XW304_AnalogOut")> _
    Public Shared Sub XW304_AnalogOut(ByVal fValue As Single)
    End Sub
    <DllImport("XW304.dll", EntryPoint:="XW304_SetDelay")> _
    Public Shared Sub XW304_SetDelay(ByVal Delayms As Integer)
    End Sub

    Private Sub btnWriteDO0x55_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWriteDO0x55.Click
        Dim dwDO, dwDI As UInteger
        dwDO = 0
        dwDI = dwDO
        Try
            If Convert.ToUInt32(txtBDoValue.Text, 16) < (&HF + 1) Then
                XWBoard.XWB_WriteDO(8, Convert.ToUInt32(txtBDoValue.Text, 16)) ' XW107 8DI 8DO
            Else
                MessageBox.Show("The XW304 only have 4 DO.")
                txtBDoValue.Text = "0xF"
            End If
        Catch ee As Exception
            MessageBox.Show("Error Value")
        End Try
        XWBoard.XWB_ReadDO(4, dwDO)

        textBox1.Text = "DO Readback=" & dwDO.ToString("X")
    End Sub

    Private Sub checkBox0_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkBox0.CheckStateChanged
        Dim dwDO As UInteger
        Dim dwDI As UInteger
        dwDO = 0
        dwDI = dwDO
        If checkBox0.Checked Then
            XWBoard.XWB_WriteDOBit(4, 0, 1)
        Else
            XWBoard.XWB_WriteDOBit(4, 0, 0)
        End If
        XWBoard.XWB_ReadDO(4, dwDO)
        textBox1.Text = "DO Readback=" & dwDO.ToString("X")
    End Sub

    Private Sub checkBox1_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkBox1.CheckStateChanged
        Dim dwDO As UInteger
        Dim dwDI As UInteger
        dwDO = 0
        dwDI = dwDO
        If checkBox1.Checked Then
            XWBoard.XWB_WriteDOBit(4, 1, 1)
        Else
            XWBoard.XWB_WriteDOBit(4, 1, 0)
        End If
        XWBoard.XWB_ReadDO(4, dwDO)
        textBox1.Text = "DO Readback=" & dwDO.ToString("X")
    End Sub

    Private Sub checkBox2_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkBox2.CheckStateChanged
        Dim dwDO As UInteger
        Dim dwDI As UInteger
        dwDO = 0
        dwDI = dwDO
        If checkBox2.Checked Then
            XWBoard.XWB_WriteDOBit(4, 2, 1)
        Else
            XWBoard.XWB_WriteDOBit(4, 2, 0)
        End If
        XWBoard.XWB_ReadDO(4, dwDO)
        textBox1.Text = "DO Readback=" & dwDO.ToString("X")
    End Sub

    Private Sub checkBox3_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkBox3.CheckStateChanged
        Dim dwDO As UInteger
        Dim dwDI As UInteger
        dwDO = 0
        dwDI = dwDO
        If checkBox3.Checked Then
            XWBoard.XWB_WriteDOBit(4, 3, 1)
        Else
            XWBoard.XWB_WriteDOBit(4, 3, 0)
        End If
        XWBoard.XWB_ReadDO(4, dwDO)
        textBox1.Text = "DO Readback=" & dwDO.ToString("X")
    End Sub

    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
        Dim dwDI As UInteger = 0
        XWBoard.XWB_ReadDI(4, dwDI)
        reverse(dwDI)
        textBox2.Text = "DI Readback=" & (dwDI And &HF).ToString("X")
    End Sub

    Dim ai_type As Integer = 0 '0 Ai read range -5~+5, 1 Ai read range 0~+5
    Private Sub button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button2.Click
        Dim iChannel_Readed As Integer
        Dim fAIValue As Single = 0
        XW304_SetDelay(125) 'If the value sets more big, the Ai read speed more slow, but the Ai read value more accurate

        iChannel_Readed = comboBoxAiCh.SelectedIndex

        XW304_ReadAi(iChannel_Readed, ai_type, fAIValue)
        txbAiValue.Text = fAIValue.ToString()
    End Sub

    Private Sub button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button3.Click
        Dim fAoValue As Single = 0
        fAoValue = CSng(Double.Parse(tBxAoValue.Text))
        XW304_AnalogOut(fAoValue)
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        comboBoxAiCh.SelectedIndex = 0
        XW304_Init()
        XW304_AnalogOut(0.0F)
    End Sub
End Class
