// DIODlg.cpp : implementation file
//

#include "stdafx.h"
#include "DIO.h"
#include "DIODlg.h"
#include "pacsdk.h"
#include "XWboardSDK.h"
#include "XW304.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDIODlg dialog

CDIODlg::CDIODlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDIODlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDIODlg)
	m_Channel_Readed = _T("");
	m_AIValue = _T("");
	m_AoValue = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDIODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDIODlg)
	DDX_Control(pDX, IDC_CHECK1, m_ch0);
	DDX_Control(pDX, IDC_CHECK2, m_ch1);
	DDX_Control(pDX, IDC_CHECK3, m_ch2);
	DDX_Control(pDX, IDC_CHECK4, m_ch3);
	DDX_Control(pDX, IDC_CHECK9, m_DiReverse);
	DDX_Text(pDX, IDC_EDITCh_Readed, m_Channel_Readed);
	DDX_Text(pDX, IDC_EDITAIValue, m_AIValue);
	DDX_Text(pDX, IDC_EDITAoValue, m_AoValue);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDIODlg, CDialog)
	//{{AFX_MSG_MAP(CDIODlg)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_BN_CLICKED(IDC_CHECK3, OnCheck3)
	ON_BN_CLICKED(IDC_CHECK4, OnCheck4)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDIODlg message handlers

TCHAR tstemp[128];
 


BOOL CDIODlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen	
	XWB_Init(0);//auto scanner module
	SetDlgItemText(IDC_EDIT1,TEXT("0xF"));
    SetDlgItemText(IDC_EDIT2,TEXT("DO Readback=0x0, DI=0x0"));
	m_Channel_Readed=_T("0");
	m_AIValue=_T("0.0");
	m_AoValue=_T("0.000");
	UpdateData(false);
	XW304_Init();
	XW304_AnalogOut(0.0);	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDIODlg::OnButton5() 
{
	DWORD dwDO;
	TCHAR DoValue[10];
	GetDlgItemText(IDC_EDIT1,DoValue,128);
	if(_wtoi(DoValue)<0x10)
	{
	XWB_WriteDO(4,_wtoi(DoValue));// XW407 4DI 4DO
	XWB_ReadDO(4,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
	}
	else
		SetDlgItemText(IDC_EDIT1,TEXT("0xF"));	
}
void CDIODlg::reverse(DWORD *dwDI) 
{
  if (m_DiReverse.GetCheck())
  {
     *dwDI ^= 0xF;
  }
}

void CDIODlg::OnCheck1() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch0.GetCheck())
		XWB_WriteDOBit(4,0,1);
	else
		XWB_WriteDOBit(4,0,0);
	XWB_ReadDO(4,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
}

void CDIODlg::OnCheck2() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch1.GetCheck())
		XWB_WriteDOBit(4,1,1);
	else
		XWB_WriteDOBit(4,1,0);
	XWB_ReadDO(4,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
}

void CDIODlg::OnCheck3() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch2.GetCheck())
		XWB_WriteDOBit(4,2,1);
	else
		XWB_WriteDOBit(4,2,0);
	XWB_ReadDO(4,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
}

void CDIODlg::OnCheck4() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch3.GetCheck())
		XWB_WriteDOBit(4,3,1);
	else
		XWB_WriteDOBit(4,3,0);
	XWB_ReadDO(4,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
}







DWORD ai_type=0;//0 Ai read range -5~+5, 1 Ai read range 0~+5
void CDIODlg::OnButton1() 
{
	short iChannel_Readed;
	float fAIValue;
	char cTmp[15];


	UpdateData(true);              
	wcstombs(cTmp,m_Channel_Readed,15);
	iChannel_Readed=atoi(cTmp);
	if(iChannel_Readed>5)
	{
		iChannel_Readed=5;
	   m_Channel_Readed=_T("5");
	}

	XW304_SetDelay(125);//If the value sets more big, the Ai read speed more slow, but the Ai read value more accurate

	fAIValue=XW304_AnalogIn(iChannel_Readed,ai_type);
    sprintf(cTmp,"%f",fAIValue);
	
	m_AIValue=cTmp;
	UpdateData(false);
}

void CDIODlg::OnButton2() 
{
	char cTmp[15];
	UpdateData(true);
    wcstombs(cTmp,m_AoValue,15);
	XW304_AnalogOut(atof(cTmp));
}

void CDIODlg::OnButton4() 
{
	DWORD dwDI;
	XWB_ReadDI(4,&dwDI);
	reverse(&dwDI);
	swprintf(tstemp,TEXT("Di Readback=%X"),dwDI&0xf);
    SetDlgItemText(IDC_EDIT3,tstemp);
}
