// DIODlg.cpp : implementation file
//

#include "stdafx.h"
#include "DIO.h"
#include "DIODlg.h"
#include "winpacsdk.h"
#include "XWboardSDK.h"
#include "XW310C.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDIODlg dialog

CDIODlg::CDIODlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDIODlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDIODlg)
	m_Channel_Readed = _T("");
	m_AIValue = _T("");
	m_AoValue = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDIODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDIODlg)
	DDX_Control(pDX, IDC_BUTTON5, m_WriteDo);
	DDX_Control(pDX, IDC_BUTTON1, m_B1);
	DDX_Control(pDX, IDC_CHECK1, m_ch0);
	DDX_Control(pDX, IDC_CHECK2, m_ch1);
	DDX_Control(pDX, IDC_CHECK3, m_ch2);
	DDX_Control(pDX, IDC_CHECK4, m_ch3);
	DDX_Control(pDX, IDC_CHECK9, m_DiReverse);
	DDX_Text(pDX, IDC_EDITCh_Readed, m_Channel_Readed);
	DDX_Text(pDX, IDC_EDITAIValue, m_AIValue);
	DDX_Text(pDX, IDC_EDITAoValue, m_AoValue);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDIODlg, CDialog)
	//{{AFX_MSG_MAP(CDIODlg)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_BN_CLICKED(IDC_CHECK3, OnCheck3)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_CHECK9, OnCheck9)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDIODlg message handlers

TCHAR tstemp[128];
 


BOOL CDIODlg::OnInitDialog()
{
	//CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	XWB_Init(0);//auto scanner module
	CenterWindow(GetDesktopWindow());	// center to the hpc screen	
	SetDlgItemText(IDC_EDIT1,TEXT("0x7"));
    SetDlgItemText(IDC_EDIT2,TEXT("DO Readback=0x0"));
	
	SetDlgItemText(IDC_EDITCh_Readed,TEXT("0"));
	SetDlgItemText(IDC_EDITAIValue,TEXT("0.000"));
	SetDlgItemText(IDC_EDITAoValue,TEXT("0.000"));
    
	SetDlgItemText(IDC_EDITCh_Readed2,TEXT("0"));
	XW310C_Init();

	XW310C_AnalogOut(0,0.0);	
	XW310C_AnalogOut(1,0.0);	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDIODlg::OnButton5() 
{
	DWORD dwDO;
	TCHAR DoValue[10];
	GetDlgItemText(IDC_EDIT1,DoValue,128);
	if(_wtoi(DoValue)<0x10)
	    XWB_WriteDO(3,_wtoi(DoValue));// XW310 3DI 3DO
	else
		SetDlgItemText(IDC_EDIT1,TEXT("0x7"));	
	XWB_ReadDO(3,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
}
BOOL check9=FALSE;
BOOL check9status=true;
void CDIODlg::reverse(DWORD *dwDI) 
{
  if (check9)
  {
     *dwDI ^= 0x7;
  }
}
BOOL check0=true;
void CDIODlg::OnCheck1() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;
    
	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (check0)
	{check0=FALSE;
		XWB_WriteDOBit(3,0,1);}
	else
	{check0=true;
		XWB_WriteDOBit(3,0,0);}

	XWB_ReadDO(4,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
}
BOOL check1=true;
void CDIODlg::OnCheck2() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (check1)
	{
		check1=FALSE;
		XWB_WriteDOBit(3,1,1);
	}
	else
	{
		check1=true;
		XWB_WriteDOBit(3,1,0);
	}
	XWB_ReadDO(4,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
}
BOOL check2=true;
void CDIODlg::OnCheck3() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (check2)
	{check2=FALSE;XWB_WriteDOBit(3,2,1);}
	else
	{check2=true;XWB_WriteDOBit(3,2,0);}
	XWB_ReadDO(4,&dwDO);
	swprintf(tstemp,TEXT("DO Readback=%X"),dwDO);
    SetDlgItemText(IDC_EDIT2,tstemp);
}


DWORD ai_type=0;//0 Ai read range -5~+5, 1 Ai read range 0~+5
void CDIODlg::OnButton1() 
{
	short iChannel_Readed;
	float fAIValue;
	TCHAR cTmp[15];



	GetDlgItemText(IDC_EDITCh_Readed,cTmp,64);

	iChannel_Readed= _wtoi(cTmp);
	if(iChannel_Readed>7)
	{
		iChannel_Readed=7;
	   SetDlgItemText(IDC_EDITCh_Readed,_T("7"));
	}
	if(iChannel_Readed>3&&XW310C_GetAnanlogInType())
	{
		iChannel_Readed=3;
		SetDlgItemText(IDC_EDITCh_Readed,_T("3"));
	   
	}

	XW310C_SetDelay(125);//If the value sets more big, the Ai read speed more slow, but the Ai read value more accurate

	fAIValue=XW310C_AnalogIn(iChannel_Readed);
    swprintf(cTmp,_T("%f"),fAIValue);
	SetDlgItemText(IDC_EDITAIValue,cTmp);

}

void CDIODlg::OnButton2() 
{
	short iChannel_Readed=0;
	TCHAR cTmp[15];


	GetDlgItemText(IDC_EDITCh_Readed2,cTmp,64);
	iChannel_Readed= _wtoi(cTmp);

	TCHAR cTmp1[15];

	GetDlgItemText(IDC_EDITAoValue,cTmp1,64);
	XW310C_AnalogOut(iChannel_Readed,_wtoi(cTmp1));
}

void CDIODlg::OnButton4() 
{
	DWORD dwDI;
	XWB_ReadDI(3,&dwDI);
	reverse(&dwDI);
	swprintf(tstemp,TEXT("Di Readback=%X"),dwDI&0x7);
    SetDlgItemText(IDC_EDIT3,tstemp);
}


void CDIODlg::OnCheck9() 
{
	// TODO: Add your control notification handler code here
	if(check9status)
		{check9=true;check9status=FALSE;}
	else
		{check9=FALSE;check9status=true;}
}
