// DIODlg.cpp : implementation file
//

#include "stdafx.h"
#include "DIO.h"
#include "DIODlg.h"
#include "pacsdk.h"
#include "XWboardSDK.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDIODlg dialog

CDIODlg::CDIODlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDIODlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDIODlg)
	m_Channel = _T("0");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDIODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDIODlg)
	DDX_Control(pDX, IDC_CHECK6, m_ch5);
	DDX_Control(pDX, IDC_CHECK5, m_ch4);
	DDX_Control(pDX, IDC_EDIT5, m_receive);
	DDX_Control(pDX, IDC_EDIT4, m_send);
	DDX_Control(pDX, IDC_BUTTON2, m_close);
	DDX_Control(pDX, IDC_BUTTON1, m_open);
	DDX_Control(pDX, IDC_COMBO2, m_cmbBaudRate);
	DDX_Control(pDX, IDC_COMBO1, m_cmbCOMPort);
	DDX_Control(pDX, IDC_CHECK1, m_ch0);
	DDX_Control(pDX, IDC_CHECK2, m_ch1);
	DDX_Control(pDX, IDC_CHECK3, m_ch2);
	DDX_Control(pDX, IDC_CHECK4, m_ch3);
	DDX_Control(pDX, IDC_CHECK9, m_DiReverse);
	DDX_Text(pDX, IDC_EDIT1, m_Channel);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDIODlg, CDialog)
	//{{AFX_MSG_MAP(CDIODlg)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_BN_CLICKED(IDC_CHECK3, OnCheck3)
	ON_BN_CLICKED(IDC_CHECK4, OnCheck4)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_CBN_EDITCHANGE(IDC_COMBO1, OnEditchangeCombo1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_EN_CHANGE(IDC_EDIT4, OnChangeEdit4)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_CHECK9, OnCheck9)
	ON_BN_CLICKED(IDC_CHECK5, OnCheck5)
	ON_BN_CLICKED(IDC_CHECK6, OnCheck6)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDIODlg message handlers

TCHAR tstemp[128];



BOOL CDIODlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	
	m_cmbCOMPort.SetCurSel(0);
	m_cmbBaudRate.SetCurSel(7);
	XWB_Init(0);//auto scanner module
	SetDlgItemText(IDC_EDIT1,TEXT("0x3F"));
	SetDlgItemText(IDC_EDIT4,TEXT("$01M"));
    SetDlgItemText(IDC_EDIT2,TEXT("DO Readback=0x0, DI=0x0"));
	GetDlgItem(IDC_BUTTON2)->EnableWindow( FALSE );
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDIODlg::OnButton5() 
{
	DWORD dwDO,dwDI;
	TCHAR DoValue[10];
	GetDlgItemText(IDC_EDIT1,DoValue,128);
	if(_wtoi(DoValue)<0x40)
	{
	XWB_WriteDO(6,_wtoi(DoValue)); // XW507 6DI 6DO 1 serial port
	XWB_ReadDO(6,&dwDO);
	Sleep(1);
	XWB_ReadDI(6,&dwDI);
	reverse(&dwDI);
	swprintf(tstemp,TEXT("DO Readback=%X, DI=%X"),dwDO,dwDI);
    SetDlgItemText(IDC_EDIT2,tstemp);
	}else
		SetDlgItemText(IDC_EDIT1,TEXT("0x3F"));	
}
void CDIODlg::reverse(DWORD *dwDI) 
{
  if (m_DiReverse.GetCheck())
  {
     *dwDI ^= 0x3F;
  }
}

void CDIODlg::OnCheck1() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO,dwDI;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch0.GetCheck())
		XWB_WriteDOBit(6,0,1);
	else
		XWB_WriteDOBit(6,0,0);
	XWB_ReadDO(6,&dwDO);
	Sleep(1);
	XWB_ReadDI(6,&dwDI);
	reverse(&dwDI);
	swprintf(tstemp,TEXT("DO Readback=%X, DI=%X"),dwDO,dwDI);
    SetDlgItemText(IDC_EDIT2,tstemp);
}

void CDIODlg::OnCheck2() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO,dwDI;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch1.GetCheck())
		XWB_WriteDOBit(6,1,1);
	else
		XWB_WriteDOBit(6,1,0);
	XWB_ReadDO(6,&dwDO);
	Sleep(1);
	XWB_ReadDI(6,&dwDI);
	reverse(&dwDI);
	swprintf(tstemp,TEXT("DO Readback=%X, DI=%X"),dwDO,dwDI);
    SetDlgItemText(IDC_EDIT2,tstemp);
}

void CDIODlg::OnCheck3() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO,dwDI;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch2.GetCheck())
		XWB_WriteDOBit(6,2,1);
	else
		XWB_WriteDOBit(6,2,0);
	XWB_ReadDO(6,&dwDO);
	Sleep(1);
	XWB_ReadDI(6,&dwDI);
	reverse(&dwDI);
	swprintf(tstemp,TEXT("DO Readback=%X, DI=%X"),dwDO,dwDI);
    SetDlgItemText(IDC_EDIT2,tstemp);
}

void CDIODlg::OnCheck4() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO,dwDI;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch3.GetCheck())
		XWB_WriteDOBit(6,3,1);
	else
		XWB_WriteDOBit(6,3,0);
	XWB_ReadDO(6,&dwDO);
	Sleep(1);
	XWB_ReadDI(6,&dwDI);
	reverse(&dwDI);
	swprintf(tstemp,TEXT("DO Readback=%X, DI=%X"),dwDO,dwDI);
    SetDlgItemText(IDC_EDIT2,tstemp);
}








HANDLE hPort;
HANDLE hAPI_Thread;
int CDIODlg::Func1(TCHAR *str)
{
 SetDlgItemText(IDC_EDIT5, str);
 return 0;
}
bool run=false;
UINT CDIODlg::API_Thread(LPVOID lParam)
{
	ThreadFunction* thread = (ThreadFunction*)lParam;
	run=true;
	while(run)//t1<(GetTickCount()+5000))
	{
		DWORD t1=GetTickCount();
		DWORD DataSize=uart_GetDataSize(hPort,0);//0 input 1 ouput
		if(t1<(GetTickCount()+5000)&&DataSize>0)
		{
				Sleep(1000);
				TCHAR strTemp[100];
				char TEMP[100];
				uart_BinRecv(hPort, TEMP,DataSize);
				DataSize=0;
				pac_AnsiToWideString(TEMP,strTemp);
				thread->_this->Func1(strTemp);      
		}
	}
	return 0; 
}

void CDIODlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	TCHAR strTemp[10];
	TCHAR strTemp1[10];
	char TEMP[10];
	char TEMP1[10];
	char ConnectionString[32];
	GetDlgItemText(IDC_COMBO1,strTemp,10);
	GetDlgItemText(IDC_COMBO2,strTemp1,10);
	pac_WideStringToAnsi(strTemp,TEMP);
	pac_WideStringToAnsi(strTemp1,TEMP1);
	sprintf(ConnectionString, "%s:,%s,N,8,1",TEMP,TEMP1);
	hPort = uart_Open(ConnectionString);
	if(hPort==INVALID_HANDLE_VALUE )
	{ 
		AfxMessageBox(_T("Open Com Error"));
	}
	GetDlgItem(IDC_BUTTON1)->EnableWindow( FALSE );
	GetDlgItem(IDC_BUTTON2)->EnableWindow( TRUE );
}

void CDIODlg::OnEditchangeCombo1() 
{
	// TODO: Add your control notification handler code here
	
}

void CDIODlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	uart_Close(hPort);
	GetDlgItem(IDC_BUTTON1)->EnableWindow( TRUE );
	GetDlgItem(IDC_BUTTON2)->EnableWindow( FALSE );
	run=false;
}

void CDIODlg::OnChangeEdit4() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	
}

void CDIODlg::OnButton3() 
{
	// TODO: Add your control notification handler code here
	TCHAR strTemp[100];
	char TEMP[100];
	char RecBuf[100];
	GetDlgItemText(IDC_EDIT4,strTemp,100);
	pac_WideStringToAnsi(strTemp,TEMP);
	uart_SendCmd( hPort, TEMP, RecBuf);
	pac_AnsiToWideString(RecBuf,strTemp);
	SetDlgItemText(IDC_EDIT5,strTemp);
}



void CDIODlg::OnCheck9() 
{
	// TODO: Add your control notification handler code here
	
}

void CDIODlg::OnCheck5() 
{
	// TODO: Add your control notification handler code here
		TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO,dwDI;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch4.GetCheck())
		XWB_WriteDOBit(6,4,1);
	else
		XWB_WriteDOBit(6,4,0);
	XWB_ReadDO(6,&dwDO);
	Sleep(1);
	XWB_ReadDI(6,&dwDI);
	reverse(&dwDI);
	swprintf(tstemp,TEXT("DO Readback=%X, DI=%X"),dwDO,dwDI);
    SetDlgItemText(IDC_EDIT2,tstemp);
}

void CDIODlg::OnCheck6() 
{
	// TODO: Add your control notification handler code here
	TCHAR tcTemp[100]={0};
	int iChannel;
	DWORD dwDO,dwDI;

	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	iChannel= _wtoi(tcTemp);

	if (m_ch5.GetCheck())
		XWB_WriteDOBit(6,5,1);
	else
		XWB_WriteDOBit(6,5,0);
	XWB_ReadDO(6,&dwDO);
	Sleep(1);
	XWB_ReadDI(6,&dwDI);
	reverse(&dwDI);
	swprintf(tstemp,TEXT("DO Readback=%X, DI=%X"),dwDO,dwDI);
    SetDlgItemText(IDC_EDIT2,tstemp);
}

void CDIODlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	uart_Close(hPort);
	CDialog::OnClose();
}
